(
	--Swap vraycolor and vraybitmap primaries to ACEScg
	global colorSpaceSwapperRoll
	try (destroydialog colorSpaceSwapperRoll) catch ()
	
	theMaps = #()
	theColors= #()
	theMats=#()
	infoText = ""
	theMap = undefined
	recursing = false
	csNames = #("sRGB", "ACEScg")
	
	fn collectInfo =
	(
		theMaps = getClassInstances vrayBitmap
		theColors= getClassinstances vrayColor
		infoText = "Found a total of " + theMaps.count as string + " V-Ray Bitmaps\nand a total of " + theColors.count as string + " V-Ray Colors\nto process"
		
		colorSpaceSwapperRoll.infoLbl.text = infoText
	)
	

	fn processMaps mode =
	(
		st = timestamp()

		theMaps = getClassInstances vrayBitmap
		theColors= getClassinstances vrayColor		
		if theMaps.count > 0 do
		(
			format "Modifying VRayBitmaps\n"
			for m in theMaps do
			(
				for r in (refs.dependents m) where superclassof r == material do
				(
					m.rgbColorSpace = mode 
					format "Processed texture `%` to have RGB primaries set to %\n" m.name csNames[mode]
				)
			)
		)
		if theColors.count > 0 do
		(
			format "Modifying VRayColors\n"
			for c in theColors do
			(
				for r in (refs.dependents c) where superclassof r == material do
				(
					c.rgb_primaries = mode 
					format "Processed color `%` to have RGB primaries set to %\n" c.name csNames[mode]
				)
			)
	
		)
		totTime = (timestamp() - st) / 1000.
		if totTime > 86.400 do totTime -= 86.400
		format "Scene processing took %s.\n" totTime
	)
	
	rollout colorSpaceSwapperRoll "ColorSpace Swapper v 0.03" width:280 height:216
	(
		button 'refreshBtn' "Refresh Info" pos:[8,8] width:264 height:24 align:#left		
		groupBox 'grp1' "Info:" pos:[8,40] width:264 height:96 align:#left		
		label 'infoLbl' "" pos:[16,64] width:248 height:64 align:#left
		
		groupBox 'grp2' "Execution:" pos:[8,144] width:264 height:64 align:#left		
		button 'acesBtn' "ACEScg" pos:[16,160] width:120 height:40 align:#left
		button 'srgbBtn' "sRGB" pos:[144,160] width:120 height:40 align:#left

		on colorSpaceSwapperRoll open do collectInfo()
		on refreshBtn pressed do collectInfo() 
		
		on acesBtn pressed do
		(
			collectInfo()
			with undo label:("Primaries to ACEScg") on processMaps 2
		)
		on srgbBtn pressed do
		(
			collectInfo()
			with undo label:("Primaries to sRGB") on processMaps 1			
		)
	)
	
	createDialog colorSpaceSwapperRoll
)